%%
%% This is file `semengo.cls',
%% generated with the docstrip utility.
%%
%% The original source files were:
%%
%% semengo.dtx  (with options: `class')
%% This is a generated file.
%% 
%% Copyright 2020 by Phelype Oleinik /phelype.oleinik at latex-project.org/
%% 
%% This work may be distributed and/or modified under the conditions of the
%% LaTeX Project Public License, either version 1.3c of this license or (at
%% your option) any later version. The latest version of this license is in
%% 
%%     http://www.latex-project.org/lppl.txt
%% 
%% and version 1.3c or later is part of all distributions of LaTeX version
%% 2005/12/01 or later.
%% 
%% This work is "maintained" (as per the LPPL maintenance status)
%% by Phelype Oleinik.
%% 
\def\msf@date{2020/03/03}
\def\msf@version{1.0}
\def\msf@base{article}
\NeedsTeXFormat{LaTeX2e}[2005/12/01]
\RequirePackage{xparse,l3keys2e}
\ProvidesExplClass{semengo}{\msf@date}{\msf@version}{%
  SEMENGO --- LaTeX document class for MCSul/SEMENGO
}
\int_const:Nn \c__msf_event_edition_int { 10 }
\tl_new:N \g__msf_biblatex_backend_tl
\tl_gset:Nn \g__msf_biblatex_backend_tl { bibtex }
\cs_new:Npn \__msf_tmp:w { }
\tl_new:N \l__msf_tmpa_tl
\tl_new:N \l__msf_tmpb_tl
\seq_new:N \l__msf_tmpa_seq
\box_new:N \l__msf_tmpa_box
\keys_define:nn { msf } % for the record, MSF = MCSul SEMENGO FURG
  {
    , no-fonts .bool_gset:N = \g__msf_load_fonts_bool
    , no-fonts .initial:n = true
    , no-fonts .default:n = false
    , use-biber .code:n =
        { \tl_gset:Nn \g__msf_biblatex_backend_tl { biber } }
    , times-new-roman .bool_gset:N = \g__msf_tnr_bool
    , times-new-roman .initial:n = false
    , times-new-roman .default:n = true
    , unknown  .code:n =
        { \PassOptionsToClass { \CurrentOption } { \msf@base } }
  }
\keys_set:nn { msf } { final } % defaults
\ProcessKeysOptions { msf }
\keys_set:nn { msf } { 12pt , a4paper , oneside , onecolumn , titlepage }
\LoadClass { \msf@base }
\prop_if_exist:NT  \g_msg_module_name_prop
  {
    \prop_gput:Nnn \g_msg_module_name_prop { msf } { SEMENGO }
    \prop_gput:Nnn \g_msg_module_type_prop { msf } { Class }
  }
\RequirePackage{babel}
\tl_if_empty:NT \bbl@loaded
  {
    \msg_new:nnn { msf } { no-language }
      {
        No~language~loaded.\\
        Please~specify~a~language~option~in:\\
        \use:n { ~ } ~ \iow_char:N\\documentclass[<language>]{semengo}
      }
    \msg_error:nn { msf } { no-language }
  }
\RequirePackage[
  left = 3.5cm , right  = 2.5cm ,
  top  = 2.5cm , bottom = 3.0cm ,
  a4paper, footskip=50pt
  ]{geometry}
\RequirePackage{indentfirst}
\RequirePackage{setspace}
\RequirePackage{graphicx}
\cs_gset_protected:Npn \__msf_tmp:w #1 #2
  {
    \quark_if_recursion_tail_stop:n {#1}
    \if_meaning:w \l__msf_tmpa_tl #1
      \tl_set:Nn \l__msf_tmpa_tl {#2}
    \else:
      \if_meaning:w \l__msf_tmpb_tl #1
        \tl_set:Nn \l__msf_tmpb_tl {#2}
      \else:
        \cs_if_exist:cT { captions #1 }
          {
            \exp_args:Ncx \addto { captions #1 }
              {
                \def \exp_not:c { \l__msf_tmpa_tl name }
                  { \exp_not:V \l__msf_tmpb_tl }
              }
          }
      \fi:
    \fi:
    \__msf_tmp:w {#2}
  }
\tl_set:Nn \l__msf_tmpa_tl { word }
\tl_set:Nn \l__msf_tmpb_tl { meaning }
\__msf_tmp:w
  \l__msf_tmpa_tl { keywords }
  \l__msf_tmpb_tl { Keywords }
    { english } { UKenglish } { british } { american }
    { USenglish } { canadian } { australian } { newzealand }
  \l__msf_tmpb_tl { Palavras-chave }
    { portuges } { portuguese } { brazil } { brazilian }
  \l__msf_tmpb_tl { Palabras~clave }
    { spanish }
  \l__msf_tmpb_tl { MISSING~LANGUAGE }
    { nil }
  \q_recursion_tail \q_recursion_tail
  \q_recursion_stop
\msg_new:nnn { msf } { unknown-microtype }
  {
    Unknown~`microtype'~package~version.~Please~report~a~bug.\\
    Check~if~output~is~valid.
  }
\prg_new_conditional:Npnn \__msf_if_unicode_engine: { T, F, TF }
  {
    \if_int_compare:w 0
        \sys_if_engine_xetex:T { 1 }
        \sys_if_engine_luatex:T { 1 }
          > 0 \exp_stop_f:
      \prg_return_true:
    \else:
      \prg_return_false:
    \fi:
  }
\bool_if:NTF \g__msf_load_fonts_bool
  { % We have to cope with some pretty archaic expl3
    %  versions, so some \sys functions are no game
    \__msf_if_unicode_engine:TF
      {
        \RequirePackage{fontspec}
        \RequirePackage{unicode-math}
        \newfontfamily \__msf_sc_font: {TeX~Gyre~Termes} [ Scale = 1.22 ]
        \bool_if:NTF \g__msf_tnr_bool
          { \setmainfont{Times~New~Roman} [ Scale = 1.22 ] }
          { \setmainfont{TeX~Gyre~Termes} [ Scale = 1.22 ] }
        \setsansfont{TeX~Gyre~Heros} [ Scale = MatchLowercase ]
        \setmonofont{Fira~Mono} [ Scale = MatchLowercase ]
        \setmathfont{TeX~Gyre~Termes~Math}
        \cs_new:Npn \__msf_letterspace:n #1
          { \addfontfeature { LetterSpace = #1.0 } }
      }
      {
        % \RequirePackage[scale=1.19]{tgtermes}
        \RequirePackage[scaled=1.22]{newtxtext} % already loads tgheros
        \RequirePackage[scaled=1.03]{FiraMono}
        \RequirePackage{newtxmath}
        \RequirePackage{microtype}
        \cs_new_eq:NN \__msf_sc_font: \prg_do_nothing:
        \bool_if:NTF \g__msf_tnr_bool
          {
            \msg_new:nnn { msf } { no-times-new-roman }
              {
                Times~New~Roman~cannot~be~used~with~pdfLaTeX.\\
                Use~LuaLaTeX~or~XeLaTeX~instead.
              }
            \msg_warning:nn { msf } { no-times-new-roman }
          }
        \cs_if_exist:NTF \MT@ls@set@ls
          {
            \cs_new:Npn \__msf_letterspace:n #1
              {
                \cs_set_eq:NN \MT@ls@adjust@ \MT@ls@adjust@relax
                \MT@ls@set@ls {#10} \lsstyle
              }
          }
          {
            \cs_new:Npn \__msf_letterspace:n #1 #2
              { \noindent \textls [#10] {#2} }
            \msg_warning:nn { msf } { unknown-microtype }
          }
      }
  }
  {
    \cs_new_eq:NN \__msf_letterspace:n \use_none:n
    \cs_new_eq:NN \__msf_sc_font: \prg_do_nothing:
  }
\__msf_if_unicode_engine:F
  {
    \cs_if_exist:NF \UseRawInputEncoding
      { \RequirePackage[utf8]{inputenc} }
  }
\cs_if_exist:NF \str_if_eq:eeTF
  {
    \prg_new_eq_conditional:NNn
      \str_if_eq:ee \str_if_eq_x:nn { T, F, TF, p }
  }
\cs_if_exist:NF \box_use_drop:N
  { \cs_new_eq:NN \box_use_drop:N \tex_box:D }
\prop_new:N \l__msf_internal_prop
\cs_if_exist:NF \prop_gset_from_keyval:Nn
  {
    \cs_new_protected:Npn \prop_gset_from_keyval:Nn #1#2
      {
        \prop_clear:N \l__msf_internal_prop
        \keyval_parse:NNn \__msf_prop_missing_equals:n
          \__msf_prop_from_keyval:nn {#2}
        \prop_gset_eq:NN #1 \l__msf_internal_prop
        \prop_clear:N \l__msf_internal_prop
      }
  }
\cs_new_protected:Npn \__msf_prop_missing_value:n #1
  { \msg_error:nnn { msf } { prop-missing-equals } {#1} }
\msg_new:nnn { msf } { prop-missing-equals }
  { Missing~`='~in~key-value~list~\msg_line_context:. }
\cs_new_protected:Npn \__msf_prop_from_keyval:nn #1 #2
  { \prop_put:Nnn \l__msf_internal_prop {#1} {#2} }
\cs_if_exist:NF \tl_trim_spaces_apply:nN
  {
    \cs_new:Npn \tl_trim_spaces_apply:nN #1#2
      { \__tl_trim_spaces:nn { \q_mark #1 } { \exp_args:No #2 } }
  }
\cs_generate_variant:Nn \tl_trim_spaces:n { o }
\cs_if_exist:NF \mode_leave_vertical:
  {
    \cs_new_protected:Npn \mode_leave_vertical:
      { \if_mode_vertical: \exp_after:wN \tex_indent:D \fi: }
  }
\cs_if_exist:NF \scan_new:N
  { \cs_new_eq:NN \scan_new:N \__scan_new:N }
\cs_if_exist:NTF \tex_scantokens:D
  { \cs_new_eq:NN \__msf_scantokens:w \tex_scantokens:D }
  { \cs_new_eq:NN \__msf_scantokens:w \etex_scantokens:D }
\scan_new:N \s__msf_mark
\cs_gset:Npn \@seccntformat #1
  { \use:c { the #1 } \skip_horizontal:n { 0.8em } }
\cs_gset_protected:Npn \section
  {
    \@startsection
      { section } { 1 } { \z@ }
      { -3.5ex \@plus -1ex \@minus -.2ex }
      { 2.3ex \@plus.2ex }
      {
        \normalfont \Large \__msf_sc_font:
        \bfseries \scshape \__msf_letterspace:n {3}
      }
  }
\cs_new_protected:Npn \__msf_maketitle:
  {
    \__msf_process_author_list:
    \group_begin:
      \cs_set_eq:NN \footnotesize \small
      \thispagestyle {empty}
      \setcounter {page} { 1 }
      { \__msf_typeset_header:   }
      { \__msf_typeset_title:    }
      { \__msf_typeset_corr:     }
      { \__msf_typeset_author:   }
      { \__msf_typeset_abstract: }
      { \__msf_typeset_keywords: }
      \newpage
    \group_end:
    \setcounter {footnote} { 0 }
    \tl_map_inline:nn { \thanks \maketitle \title \author \date \and }
      { \cs_gset_eq:NN ##1 \scan_stop: }
    \tl_map_inline:nn { \@thanks \@title \@author \@date }
      { \cs_gset_eq:NN ##1 \prg_do_nothing: }
  }
\tl_new:N \g__msf_address_tl
\tl_new:N \l__msf_sanitise_tl
\prop_new:N \g__msf_address_prop
\group_begin:
  \char_set_catcode_active:n { `\= }
  \cs_new_protected:Npn \__msf_sanitise_equals:
    {
      \exp_after:wN \__msf_sanitise_equals_auxi:w \l__msf_sanitise_tl
        \q_mark = \q_nil =
      \exp_after:wN \__msf_sanitise_aux:w \l__msf_sanitise_tl
    }
    \cs_new_protected:Npn \__msf_sanitise_equals_auxi:w #1 =
      {
        \tl_set:Nn \l__msf_sanitise_tl {#1}
        \__msf_sanitise_equals_auxii:w
      }
    \cs_new_protected:Npn \__msf_sanitise_equals_auxii:w #1 =
      {
        \if_meaning:w \q_nil #1 \scan_stop:
        \else:
          \tl_set:Nx \l__msf_sanitise_tl
            {
              \exp_not:o \l__msf_sanitise_tl
              \token_to_str:N =
              \exp_not:n {#1}
            }
          \exp_after:wN \__msf_sanitise_equals_auxii:w
        \fi:
      }
  \char_set_catcode_other:n { `\= }
  \cs_new_protected:Npn \__msf_address_split_eq:w #1 = #2 \s__msf_mark
    {
      \quark_if_nil:nTF {#2}
        { \msg_error:nn { msf } { missing-equals } }
        { \tl_trim_spaces_apply:nN {#1} \__msf_address_split_eq_aux:nw #2 }
    }
  \cs_new_protected:Npn \__msf_address_split_eq_aux:nw #1 #2 = \q_mark
    { \prop_gput:Nnx \g__msf_address_prop {#1} { \__msf_trim_spaces:n {#2} } }
\group_end:
\cs_new:Npn \__msf_trim_spaces:n #1
  { \tl_trim_spaces_apply:nN {#1} \__msf_trim_braces:n }
\cs_new:Npn \__msf_trim_braces:n #1
  {
    \tl_if_single:nT {#1}
      {
        \tl_if_head_is_group:nT {#1}
          { \tl_trim_spaces:o { \use:n #1 } \use_none:nn }
      }
    \exp_not:n {#1}
  }
\NewDocumentCommand \address { m }
  {
    \prop_gclear:N \g__msf_address_prop
    \seq_set_split:Nnn \l__msf_tmpa_seq { \and } {#1}
    \seq_map_inline:Nn \l__msf_tmpa_seq
      {
        \tl_set:Nn \l__msf_sanitise_tl {##1}
        \exp_after:wN \__msf_address_split_eq:w \l__msf_sanitise_tl
          = \q_mark \s__msf_mark
      }
  }
\cs_new_protected:Npn \__msf_author_addr:n #1
  { \__msf_author_addr:nn {#1} { 0 } }
\cs_new_protected:Npn \__msf_author_addr:nn #1 #2
  {
    \prop_if_in:NnTF \g__msf_address_prop {#1}
      {
        \tl_set:Nx \l__msf_tmpa_tl
          { \prop_item:Nn \g__msf_address_prop {#1} }
      }
      { \tl_set:Nn \l__msf_tmpa_tl { \textbf { #1?? } } }
    \cs_if_exist:cTF { __msf-#1-index }
      { \footnotemark[ \use:c { __msf-#1-index } ] }
      {
        \footnotemark
        \tl_gput_right:Nx \g__msf_address_tl
          {
            \exp_not:N \stepcounter { footnote }
            \exp_not:N \footnotetext
              {
                \tex_sfcode:D `. = 2999 \exp_stop_f:
                \exp_not:N \strut
                \exp_not:V \l__msf_tmpa_tl
                \__msf_check_period:n { . }
              }
          }
        \cs_set:cpx { __msf-#1-index } { \arabic {footnote} }
      }
    \group_begin:
      \cs_set:Npn \thefootnote { \fnsymbol {footnote} }
      \footnotemark [#2]
    \group_end:
  }
\cs_new_protected:Npn \__msf_email:n #1
  { \texttt{ \tl_to_str:n {#1} } }
\cs_new_protected:Npn \__msf_check_period:n #1
  { \int_compare:nNnF { \tex_spacefactor:D } = { 2999 } {#1} }
\tl_new:N \l__msf_author_sanitise_tl
\tl_new:N \l__msf_author_addr_tl
\tl_new:N \l__msf_author_corr_tl
\seq_new:N \l__msf_author_output_seq
\int_new:N \l__msf_author_corr_int
\tl_new:N \g__msf_author_corr_tl
\scan_new:N \s__msf_author
\cs_new_protected:Npn \__msf_process_author_list:
  {
    \tl_clear:N \l__msf_author_sanitise_tl
    \int_zero:N \l__msf_author_corr_int
    \seq_clear:N \l__msf_author_output_seq
    \seq_set_split:NnV \l__msf_tmpa_seq { \and } \@author
    \seq_map_function:NN \l__msf_tmpa_seq \__msf_parse_author:n
    \tl_gset_eq:NN \@author \l__msf_author_sanitise_tl
  }
\cs_new_protected:Npn \__msf_parse_author:n #1
  {
    \tl_if_empty:nT {#1} { \__msf_abort_author:w }
    \tl_set:Nn \l__msf_tmpa_tl {#1}
    \tl_clear:N \l__msf_author_addr_tl
    \tl_clear:N \l__msf_author_corr_tl
    \tl_if_in:NnT \l__msf_tmpa_tl { \addr }
      { \__msf_check_addr:N \l__msf_tmpa_tl }
    \tl_if_in:NnT \l__msf_tmpa_tl { \corr }
      { \__msf_check_corr:N \l__msf_tmpa_tl }
    \tl_trim_spaces:N \l__msf_tmpa_tl
    \tl_if_empty:NT \l__msf_author_addr_tl
      {
        \msg_warning:nnx { msf } { missing-author-addr }
          { \l__msf_author_sanitise_tl }
        \tl_set:Nx \l__msf_author_addr_tl
          { \exp_not:N \textbf { \token_to_str:N \addr ?? } }
      }
    \tl_if_empty:NF \l__msf_author_corr_tl
      {
        \int_incr:N \l__msf_author_corr_int
        \tl_gput_right:Nx \g__msf_author_corr_tl
          {
            \exp_not:N \footnotetext [ \int_use:N \l__msf_author_corr_int ]
            { \exp_not:N \__msf_email:n { \exp_not:V \l__msf_author_corr_tl } }
          }
      }
    \seq_put_right:Nx \l__msf_author_output_seq
      {
        \hbox:n { \exp_not:V \l__msf_tmpa_tl }
        \tl_if_empty:NTF \l__msf_author_corr_tl
          { \__msf_author_addr:n { \exp_not:V \l__msf_author_addr_tl } }
          {
            \__msf_author_addr:nn
              { \exp_not:V \l__msf_author_addr_tl }
              { \int_use:N \l__msf_author_corr_int }
          }
      }
    \tl_put_right:Nx \l__msf_author_sanitise_tl \l__msf_tmpa_tl
    \s__msf_author
  }
\msg_new:nnn { msf } { missing-author-addr }
  { Missing~\iow_char:N\\addr~for~author~`#1'. }
\cs_new_protected:Npn \__msf_abort_author:w #1 \s__msf_author { }
\cs_new_protected:Npn \__msf_check_addr:N #1
  { \exp_last_unbraced:NNV \__msf_check_addr:Nw #1 #1 \s__msf_mark }
\cs_new_protected:Npn \__msf_check_addr:Nw #1 #2 \addr#3 #4 \s__msf_mark
  {
    \tl_set:Nn \l__msf_author_addr_tl {#3}
    \tl_set:Nn #1 {#2 #4}
    \prop_if_in:NnF \g__msf_address_prop {#3}
      { \msg_warning:nnn { msf } { missing-address } {#3} }
  }
\msg_new:nnn { msf } { missing-address }
  { Address~line~`#1'~not~declared~in~\iow_char:N\\address. }
\cs_new_protected:Npn \__msf_check_corr:N #1
  { \exp_last_unbraced:NNV \__msf_check_corr:Nw #1 #1 \s__msf_mark }
\cs_new_protected:Npn \__msf_check_corr:Nw #1 #2 \corr#3 #4 \s__msf_mark
  {
    \tl_set:Nn \l__msf_author_corr_tl {#3}
    \tl_set:Nn #1 {#2 #4}
  }
\cs_new_protected:Npn \__msf_typeset_author_list:
  {
    \mode_leave_vertical:
    \seq_use:Nn \l__msf_author_output_seq
      { \tex_discretionary:D { } { } { \hbox:n { ;~ } } }
    \setcounter {footnote} { 0 }
    \tl_use:N \g__msf_address_tl
  }
\tl_map_inline:nn { \addr \corr }
  {
    \cs_gset_protected:Npn #1 ##1
      { \msg_error:nnx { msf } { author-cmd } { \token_to_str:N #1 } }
  }
\cs_gset_protected:Npn \and
  { \msg_error:nnx { msf } { author-cmd } { \token_to_str:N \and } }
\msg_new:nnn { msf } { author-cmd }
  { Misplaced~command~'#1'.~Use~it~inside~\iow_char:N\\author. }
\tl_new:N \g__msf_logo_file_tl
\NewDocumentCommand \mainlogo { m }
  { \tl_gset:Nn \g__msf_logo_file_tl {#1} }
\mainlogo { logo }
\cs_new_protected:Npn \__msf_typeset_header:
  {
    \tex_noindent:D
    \includegraphics
      [width=\textwidth]
      { \g__msf_logo_file_tl }
    \tex_par:D
  }
\tl_map_function:nN
  { \mainlogo \author \address \title \abstract \keywords }
  \@onlypreamble
\cs_new_protected:Npn \__msf_typeset_title:
  {
    \skip_vertical:n { 12pt }
    \centering
    \LARGE
    \bfseries
    \__msf_letterspace:n { 5 }
    \@title
    \tex_par:D
  }
\cs_new_protected:Npn \__msf_typeset_corr:
  {
    \group_begin:
      \cs_set:Npn \thefootnote { \fnsymbol {footnote} }
      \tl_use:N \g__msf_author_corr_tl
    \group_end:
  }
\cs_new_protected:Npn \__msf_typeset_author:
  {
    \skip_vertical:n { 12pt }
    \raggedleft
    \large
    \normalfont
    \__msf_typeset_author_list:
    \tex_par:D
  }
\tl_new:N \g__msf_abstract_tl
\cs_gset_protected:Npn \abstract
  {
    \str_if_eq:eeTF { \@currenvir } { abstract }
      { \__msf_abstract_env:w }
      { \msg_error:nn { msf } { abstract-command } }
  }
\msg_new:nnn { msf } { abstract-command }
  {
    Invalid~usage~of~\iow_char:N\\abstract.~Use:\\
    \iow_char:N\\begin{abstract}\\
    \use:n { ~ } ~ ...\\
    \iow_char:N\\end{abstract}\\
    instead.
  }
\cs_new_protected:Npn \__msf_abstract_env:w
  {
    \tl_gclear:N \g__msf_abstract_tl
    \group_begin:
      \tl_map_function:nN { \  \" \# \$ \% \& \\ \^ \_ \{ \} \~ }
        \char_set_catcode_other:N
      \char_set_catcode_active:N \^^M
      \char_set_active_eq:NN \^^M \__msf_abstract:w
      \exp_after:wN \__msf_abstract:w \__msf_use_none_delimit_by_cr:w
  }
\group_begin:
  \char_set_catcode_active:N \^^M
  \char_set_catcode_other:N \^^J
  \cs_new:Npn \__msf_use_none_delimit_by_cr:w #1 ^^M { }
  \cs_new_protected:Npn \__msf_abstract:w #1 ^^M
    {
      \__msf_if_end_abstract:nTF {#1}
        { \end{abstract} }
        {
          \tl_gput_right:Nn \g__msf_abstract_tl { #1 ^^J }
          \__msf_abstract:w
        }
    }
  \cs_new_protected:Npn \__msf_sanitise_abstract_head:n #1
    {
      \tl_if_head_eq_charcode:nNTF {#1} ^^J
        {
          \tl_gset:Nx \g__msf_abstract_tl
            { \exp_not:o { \__msf_gobble_nl:w #1 } }
          \exp_args:NV \__msf_sanitise_abstract_head:n \g__msf_abstract_tl
        }
        {
          \tl_gset:Nx \g__msf_abstract_tl
            {
              \exp_after:wN \__msf_sanitise_abstract_tail:w
                \g__msf_abstract_tl \s__msf_mark
            }
          \exp_args:NV \__msf_check_nl_nl:n \g__msf_abstract_tl
        }
    }
  \cs_new_protected:Npn \__msf_check_nl_nl:n #1
    { \__msf_check_nl_nl:w #1 ^^J ^^J \q_mark \s__msf_mark }
  \cs_new_protected:Npn \__msf_check_nl_nl:w #1 ^^J ^^J #2 \s__msf_mark
    {
      \tl_if_single_token:nTF {#2}
        {
          \token_if_eq_meaning:NNF \q_mark #2
            { \__msf_par_in_abstract: }
        }
        { \__msf_par_in_abstract: }
    }
  \cs_new:Npn \__msf_sanitise_abstract_tail:w #1 \s__msf_mark
    {
      \__msf_trim_nl_loop:w  #1\s__msf_mark
      \__msf_trim_nl_loop:w ^^J\s__msf_mark
      \__msf_trim_nl_end:w \s_stop
    }
  \cs_new:Npn \__msf_trim_nl_loop:w #1 ^^J\s__msf_mark #2 { #2 #1\s__msf_mark #2 }
  \cs_new:Npn \__msf_trim_nl_end:w #1\s__msf_mark #2 \s_stop { \exp_not:n {#1} }
  \cs_new:Npn \__msf_gobble_nl:w ^^J { }
\group_end:
\tl_set:Nx \l__msf_tmpa_tl
  { \c_backslash_str end \c_left_brace_str abstract \c_right_brace_str }
\use:x
  {
    \prg_new_protected_conditional:Npnn
        \exp_not:N \__msf_if_end_abstract:n ##1 { TF }
      {
        \exp_not:N \tl_if_blank:nTF {##1}
          { \exp_not:N \prg_return_false: }
          {
            \exp_not:N \__msf_if_end_abstract:w ##1
              \l__msf_tmpa_tl \s__msf_mark
          }
      }
    \cs_new_protected:Npn \exp_not:N \__msf_if_end_abstract:w
        ##1 \l__msf_tmpa_tl ##2 \s__msf_mark
      {
        \exp_not:N \tl_if_blank:nTF {##1}
          { \exp_not:N \prg_return_true: }
          { \exp_not:N \prg_return_false: }
      }
  }
\cs_gset_protected:Npn \endabstract
  {
    \group_end:
    \exp_args:NV \__msf_sanitise_abstract_head:n \g__msf_abstract_tl
  }
\cs_new_protected:Npn \__msf_par_in_abstract:
  { \msg_warning:nn { msf } { par-in-abstract } }
\msg_new:nnn { msf } { par-in-abstract }
  { The~abstract~should~be~a~single~paragraph. }
\box_new:N \g__msf_abstract_box
\cs_new_protected:Npn \__msf_typeset_abstract:
  {
    \skip_vertical:n { 12pt }
    \normalsize
    \normalfont
    \tex_noindent:D
    \textbf{ \abstractname :~ }
    \exp_args:NV \__msf_scantokens:w \g__msf_abstract_tl
  }
\seq_new:N \g__msf_keywords_seq
\NewDocumentCommand \keywords { m }
  { \seq_gset_from_clist:Nn \g__msf_keywords_seq {#1} }
\cs_new_protected:Npn \__msf_typeset_keywords:
  {
    \skip_vertical:n { 12pt }
    \cs_if_exist:NF \keywordsname
      {
        \msg_error:nnn { msf } { unknown-word } { keywords }
        \tl_set:Nn \keywordsname { Keywords }
      }
    \normalsize
    \normalfont
    \tex_noindent:D
    \textbf { \keywordsname :~ }
    \seq_use:Nn \g__msf_keywords_seq { ;~ }
  }
\msg_new:nnn { msf } { unknown-word }
  {
    Unknown~word~`#1'.\\
    Please~define~it~with:\\
    \use:n{~}~
    \iow_char:N\\addto\iow_char:N\\captions
      \languagename { \iow_char:N\\def\iow_char:N\\#1name{<name>} }
  }
\cs_gset_protected:Npn \@float #1
  {
    \peek_charcode_ignore_spaces:NTF [ % ]
      { \@xfloat {#1} }
      { \@xfloat {#1} [htbp] }
  }
\cs_gset:Npn \ps@plain
  {
    \cs_set_eq:NN \@mkboth \use_none:nn
    \cs_set_eq:NN \@oddhead \prg_do_nothing:
    \cs_set_eq:NN \@evenhead \prg_do_nothing:
    \cs_set_protected:Npn \@oddfoot
      { \hfil \bfseries \__msf_typeset_footer: \hfil }%
    \cs_set_eq:NN \@evenfoot \@oddfoot
  }
\cs_new_protected:Npn \__msf_typeset_footer:
  {
    \int_to_arabic:n { \c__msf_event_edition_int } \textordmasculine
    \c_space_tl MCSul~/~
    \int_to_Roman:n { \c__msf_event_edition_int }
    \c_space_tl SEMENGO~
    \textemdash \c_space_tl
    Universidade~Federal~do~Rio~Grande
  }
\pagestyle{plain}
\dim_const:Nn \c__msf_parindent_dim { 0.5cm }
\dim_const:Nn \c__msf_capmargin_dim { 0.5cm }
\cs_new_protected:Npn \__msf_define_caption:
  {
    \cs_new_protected:Npn \__msf_typeset_caption:nn ##1 ##2
      { \setstretch {1} \small { \bfseries ##1 : } ~ ##2 }
    \cs_gset_protected:Npn \@makecaption ##1##2
      {
        \skip_vertical:N \abovecaptionskip
        \hbox_set:Nn \l__msf_tmpa_box
          { \__msf_typeset_caption:nn {##1} {##2} }
        \dim_compare:nNnTF
            { \tex_hsize:D - 2 \c__msf_capmargin_dim }
            >
            { \box_wd:N \l__msf_tmpa_box }
          {
            \tex_global:D \@minipagefalse
            \tex_hfil:D \box_use_drop:N \l__msf_tmpa_box \tex_hfil:D
          }
          {
            \skip_horizontal:N \c__msf_capmargin_dim
            \parbox[t]
              { \dim_eval:n { \tex_hsize:D -2\c__msf_capmargin_dim } }
              { \__msf_typeset_caption:nn {##1} {##2} \tex_par:D }
          }
        \skip_vertical:N \belowcaptionskip
      }
  }
\RequirePackage{csquotes}
\RequirePackage{etoolbox}
\@ifpackagelater{expl3}{2016/01/04}
  { \tl_set:Nn \l__msf_tmpa_tl { giveninits } }
  { \tl_set:Nn \l__msf_tmpa_tl { firstinits } }
\use:x
  {
    \exp_not:N \RequirePackage
      [
        backend = \g__msf_biblatex_backend_tl ,
        \str_if_eq:eeTF { \g__msf_biblatex_backend_tl } { biber }
          { style = apa , }
          { bibstyle = authoryear , citestyle = authoryear-comp , }
        \l__msf_tmpa_tl = true , maxcitenames = 3 , maxbibnames = 99,
        autolang = other , dashed = false , uniquename = false ,
        uniquelist = false , useprefix = false , isbn = false ,
        date = year , url = true , doi = true , eprint = false ,
      ] {biblatex}
  }
\ExplSyntaxOff
\expandafter\patchcmd\csname abx@macro@name:andothers\endcsname
  {\bibstring{andothers}}
  {\bibstring[\emph]{andothers}}{}{}
\ExplSyntaxOn
\DeclareFieldFormat{pagetotal}{\mkpagetotal[bookpagination]{#1~p.}}
\cs_if_exist:NTF \DeclareDelimFormat
  {
    \DeclareDelimFormat [parencite] {nameyeardelim} { \addcomma \addspace }
    \DeclareDelimFormat [cite] {nameyeardelim} { \addcomma \addspace }
  }
  { \tl_gset:Nn \nameyeardelim { \addcomma \space } }
\AtBeginDocument
  {
    \tl_gset:Nn \finalandcomma { \addcomma }
    \tl_gset:Nn \finalandsemicolon { }
  }
\int_new:N \g__msf_lastcitetotal_int
\cs_gset_protected:Npn \multicitedelim
  {
    \iflastcitekey
      {
        \if_int_compare:w
          \int_compare:nNnTF
            { \c@citetotal + \c@multicitetotal - 1 } > { 2 }
            { 1 } { 0 }
          \int_compare:nNnTF
            { \g__msf_lastcitetotal_int + \c@citetotal } > { 2 }
            { 1 } { 0 }
          > 0 \exp_stop_f:
          \exp_after:wN \finalandsemicolon
        \fi:
        \addspace \bibstring {and} \c_space_tl
      }
      { \addsemicolon \c_space_tl }
    \int_compare:nNnT { \c@citetotal } = { \c@citecount }
      { \int_gset_eq:NN \g__msf_lastcitetotal_int \c@citetotal }
  }
\dim_set_eq:NN \bibhang \c_zero_dim
\defbibenvironment {bibliography}
  {
    \list { }
      {
        \dim_set_eq:NN \leftmargin \bibhang
        \dim_set:Nn \itemindent { -\c__msf_parindent_dim }
        \dim_set_eq:NN \itemsep \bibitemsep
        \dim_set_eq:NN \parsep \bibparsep
      }
  }
  { \endlist }
  { \item }
\AtEveryBibitem { \toggletrue { blx@useprefix } }
\renewbibmacro* { begentry } { \midsentence }
\cs_new_protected:Npn \__msf_settings:
  {
    \setstretch {1.38}
    \tl_set:Nn \floatpagefraction { 0.9 }
    \dim_set_eq:NN \tex_parindent:D \c__msf_parindent_dim
  }
\BeforeBeginEnvironment{document}{%
  \@ifpackageloaded{caption}{%
    \captionsetup*{%
      margin=\c__msf_capmargin_dim,
      font={small,stretch=1.15},
      labelfont+=bf,
      labelsep=colon}%
    \cs_gset_eq:NN \__msf_define_caption: \prg_do_nothing:
  }{}%
  \@ifpackageloaded{subcaption}{%
    \captionsetup*[sub]{%
      margin=\c__msf_capmargin_dim,
      font={footnotesize,stretch=1.15},
      labelfont+=bf,
      labelsep=space}%
  }{}%
  \@ifpackageloaded{subfigure}{%
    \ClassError{SEMENGO}{%
    You~shouldn't~use~the~`subfigure'~package~anymore.\MessageBreak
    It's~been~deprecated~for~a~long~time~now.\MessageBreak
    Use~`subcaption'~instead.}
  }{}%
  \@ifpackageloaded{hyperref}{%
    \cs_set_eq:NN \HyOrg@maketitle \__msf_maketitle:
    \cs_set_eq:NN \__msf_maketitle: \maketitle
  }{}%
  \@ifpackageloaded{url}{%
    \DeclareUrlCommand \__msf_email:n { \urlstyle{rm} }
  }{}%
}
\AfterEndPreamble
  {
    \__msf_settings:
    \__msf_define_caption:
    \__msf_maketitle:
  }
\endinput
%%
%% End of file `semengo.cls'.
%% This work consists of the files semengo.dtx, and
%%                                 semengo.ins,
%% and the derived files           semengo.cls, and
%%                                 semengo.pdf.
